internal::multifunction_output< Output > Class Template Reference

`#include <_flow_graph_node_impl.h>`

Inheritance diagram for internal::multifunction_output< Output >:
Collaboration diagram for internal::multifunction_output< Output >:

## Public Types

typedef Output | output_type
typedef function_output< output_type > | base_type
Public Types inherited from internal::function_output< Output >
typedef Output | output_type
typedef sender< output_type >::successor_type | successor_type
typedef broadcast_cache< output_type > | broadcast_cache_type
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

| multifunction_output (graph &g)
| multifunction_output (const multifunction_output &other)
bool | try_put (const output_type &i)
graph & | graph_reference () const
Public Member Functions inherited from internal::function_output< Output >
| function_output (graph &g)
| function_output (const function_output &other)
bool | register_successor (successor_type &r) __TBB_override
| Adds a new successor to this node. More...
bool | remove_successor (successor_type &r) __TBB_override
| Removes a successor from this node. More...
task * | try_put_task (const output_type &i)
broadcast_cache_type & | successors ()
graph & | graph_reference () const
Public Member Functions inherited from tbb::flow::interface11::sender< Output >
virtual bool | try_get (Output &)
| Request an item from the sender. More...
virtual bool | try_reserve (Output &)
| Reserves an item in the sender. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()
virtual bool | try_release ()
| Releases the reserved item. More...
virtual bool | try_consume ()
| Consumes the reserved item. More...

## Public Attributes

broadcast_cache_type | my_successors
Public Attributes inherited from tbb::flow::interface11::sender< Output >
__TBB_DEPRECATED typedef Output | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< Output >::filtered_type | filtered_type

## Protected Member Functions

task * | try_put_task (const output_type &i)
Protected Member Functions inherited from tbb::flow::interface11::sender< Output >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Friends

template<int N>
struct | emit_element

## Additional Inherited Members

Protected Attributes inherited from internal::function_output< Output >
broadcast_cache_type | my_successors
graph & | my_graph_ref

## Detailed Description

### template<typename Output>
class internal::multifunction_output< Output >

Definition at line 925 of file _flow_graph_node_impl.h.

## Member Typedef Documentation

## base_type

template<typename Output >

typedef function_output<output_type> internal::multifunction_output< Output >::base_type

Definition at line 928 of file _flow_graph_node_impl.h.

## output_type

template<typename Output >

typedef Output internal::multifunction_output< Output >::output_type

Definition at line 927 of file _flow_graph_node_impl.h.

## Constructor & Destructor Documentation

## multifunction_output() [1/2]

template<typename Output >

internal::multifunction_output< Output >::multifunction_output | ( | graph & | g | ) |

inline

Definition at line 931 of file _flow_graph_node_impl.h.

: base_type(g) {my_successors.set_owner(this);}
internal::successor_cache::set_owner
void set_owner(owner_type *owner)
Definition: _flow_graph_cache_impl.h:326
internal::multifunction_output::my_successors
broadcast_cache_type my_successors
Definition: _flow_graph_node_impl.h:920
internal::multifunction_output::base_type
function_output< output_type > base_type
Definition: _flow_graph_node_impl.h:928

References internal::multifunction_output< Output >::my_successors, and internal::successor_cache< T, M >::set_owner().

Here is the call graph for this function:

## multifunction_output() [2/2]

template<typename Output >

internal::multifunction_output< Output >::multifunction_output | ( | const multifunction_output< Output > & | other | ) |

inline

Definition at line 932 of file _flow_graph_node_impl.h.

: base_type(other.my_graph_ref) { my_successors.set_owner(this); }

References internal::multifunction_output< Output >::my_successors, and internal::successor_cache< T, M >::set_owner().

Here is the call graph for this function:

## Member Function Documentation

## graph_reference()

template<typename Output >

graph& internal::function_output< Output >::graph_reference

inline

Definition at line 918 of file _flow_graph_node_impl.h.

{ return my_graph_ref; }
internal::function_output::my_graph_ref
graph & my_graph_ref
Definition: _flow_graph_node_impl.h:921

## try_put()

template<typename Output >

bool internal::multifunction_output< Output >::try_put | ( | const output_type & | i | ) |

inline

Definition at line 934 of file _flow_graph_node_impl.h.

{
task *res = try_put_task(i);
if(!res) return false;
if(res != SUCCESSFULLY_ENQUEUED) {
FLOW_SPAWN(*res); // TODO: Spawn task inside arena
}
return true;
}
FLOW_SPAWN
#define FLOW_SPAWN(a)
Definition: flow_graph.h:65
task
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task * task
Definition: ittnotify_static.h:119
tbb::flow::internal::SUCCESSFULLY_ENQUEUED
static tbb::task *const SUCCESSFULLY_ENQUEUED
Definition: _flow_graph_impl.h:61
internal::multifunction_output::try_put_task
task * try_put_task(const output_type &i)
Definition: _flow_graph_node_impl.h:947

References FLOW_SPAWN, tbb::flow::internal::SUCCESSFULLY_ENQUEUED, task, and internal::multifunction_output< Output >::try_put_task().

Referenced by tbb::flow::interface11::async_node< Input, Output, Policy, Allocator >::try_put_functor::operator()().

Here is the call graph for this function:
Here is the caller graph for this function:

## try_put_task()

template<typename Output >

task* internal::multifunction_output< Output >::try_put_task | ( | const output_type & | i | ) |

inline protected

Definition at line 947 of file _flow_graph_node_impl.h.

{
return my_successors.try_put_task(i);
}
internal::broadcast_cache::try_put_task
task * try_put_task(const T &t) __TBB_override
Definition: _flow_graph_cache_impl.h:478

References internal::multifunction_output< Output >::my_successors, and internal::broadcast_cache< T, M >::try_put_task().

Referenced by internal::multifunction_output< Output >::try_put().

Here is the call graph for this function:
Here is the caller graph for this function:

## Friends And Related Function Documentation

## emit_element

template<typename Output >
template<int N>

friend struct emit_element

friend

Definition at line 951 of file _flow_graph_node_impl.h.

## Member Data Documentation

## my_successors

template<typename Output >

broadcast_cache_type internal::function_output< Output >::my_successors

Definition at line 920 of file _flow_graph_node_impl.h.

Referenced by internal::multifunction_output< Output >::multifunction_output(), and internal::multifunction_output< Output >::try_put_task().

The documentation for this class was generated from the following file:

- _flow_graph_node_impl.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.